﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Reflection;
using System.Reflection.Emit;
using System.Threading;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.Script.Services;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.JavaScript.Web;
using System.Configuration;
using System.Data.SqlClient;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;


    public partial class Default2 : System.Web.UI.Page
    {

        public static IEnumerable SqlDataSource1;
    //protected void Page_PreRender(object sender, EventArgs e)
    //{

    //    if (!Page.IsPostBack)
    //    {
    //        this.labelintermediario.Text = User.Identity.Name;
    //        this.labelIDintermediario.Text = ((System.Web.UI.WebControls.Label)Master.FindControl("HeadLoginView").FindControl("idIntermediario")).Text;
    //        this.labelNOMEintermediario.Text = ((System.Web.UI.WebControls.Label)Master.FindControl("HeadLoginView").FindControl("labelNOMEintermediario")).Text;

    //    }
    //}
    protected void Page_Load(object sender, EventArgs e)
    {
      
        DataView dv = (DataView)this.childData.Select(DataSourceSelectArguments.Empty);
    
        DataTable dt = dv.ToTable();
     

        JavaScriptSerializer serializer = new JavaScriptSerializer();
        List<Dictionary<string, object>> dictData = ToDictionary(dt);
     

        //Creating Table Type
        Type tableType = GetTableType(dictData);
        var inst = Array.CreateInstance(tableType, 1);
        
   

        //Converting to JSON String
        string str = DataTableToJSONWithJavaScriptSerializer(dt);


        //Generating Deserialized data
        SqlDataSource1 = serializer.Deserialize(str, inst.GetType()) as object[];
     
    }
    public string DataTableToJSONWithJavaScriptSerializer(DataTable table)
    {
        JavaScriptSerializer jsSerializer = new JavaScriptSerializer();
        List<Dictionary<string, object>> parentRow = new List<Dictionary<string, object>>();
        Dictionary<string, object> childRow;
        foreach (DataRow row in table.Rows)
        {
            childRow = new Dictionary<string, object>();
            foreach (DataColumn col in table.Columns)
            {
                childRow.Add(col.ColumnName, row[col]);
            }
            parentRow.Add(childRow);
        }
        return jsSerializer.Serialize(parentRow);
    }


    [WebMethod]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
    public static object DataSource(Syncfusion.JavaScript.DataManager value)
    {
        IEnumerable Data = SqlDataSource1;
        DataOperations dp = new DataOperations();
        List<FilteredColumn> fColList = new List<FilteredColumn>();
        if (value.Where != null)
        {
            Data = dp.PerformWhereFilter(Data, value.Where, value.Where[0].Condition);
        }
        int count = Data.AsQueryable().Count();
        if (value.Skip != null)
            Data = dp.PerformSkip(Data, value.Skip);
        if (value.Take != null)
            Data = dp.PerformTake(Data, value.Take);
        return new { result = Data, count = count };
    }

    public List<Dictionary<string, object>> ToDictionary(DataTable dt)
    {
        var columns = dt.Columns.Cast<DataColumn>();
        var Temp = dt.AsEnumerable().Select(dataRow => columns.Select(column =>
                             new { Column = column.ColumnName, Value = dataRow[column] })
                         .ToDictionary(data => data.Column, data => data.Value)).ToList();
        return Temp.ToList();
    }
    public static Type GetTableType(List<Dictionary<string, object>> dictList)
    {
        // Create needed TypeBuilder helpers
        AppDomain myDomain = Thread.GetDomain();
        AssemblyName myAsmName = new AssemblyName("Anonymous");
        AssemblyBuilder myAsmBuilder = myDomain.DefineDynamicAssembly(myAsmName, AssemblyBuilderAccess.Run);

        ModuleBuilder myModBuilder = myAsmBuilder.DefineDynamicModule(myAsmName.Name);
        TypeBuilder myTypeBuilder = myModBuilder.DefineType("TestClass", TypeAttributes.Public);

        //foreach (Dictionary<string, object> dictStep in dictList)
        //{
        Dictionary<string, object> DictList = (Dictionary<string, object>)dictList[0];
        foreach (KeyValuePair<string, object> keyValuePair in DictList)
        {
            var type = keyValuePair.Value.GetType().ToString();
            //colType.Add(type);

            Type PropertyType;
            var PropertyName = keyValuePair.Key;
            PropertyType = Type.GetType(type);
            switch (type)
            {
                case "number":
                    PropertyType = Type.GetType("System.Decimal");
                    break;

                case "string":
                    PropertyType = Type.GetType("System.String");
                    break;
                case "boolean":
                    PropertyType = Type.GetType("System.Boolean");
                    break;
                case "date":
                    PropertyType = Type.GetType("System.DateTime");
                    break;
                default:
                    PropertyType = Type.GetType("System.String");
                    break;
            }
            FieldBuilder PropertyFieldBuilder = myTypeBuilder.DefineField(PropertyName.ToLower(), PropertyType, FieldAttributes.Private);

            PropertyBuilder PBuilder = myTypeBuilder.DefineProperty(PropertyName, System.Reflection.PropertyAttributes.HasDefault, PropertyType, null);

            MethodAttributes getSetAttr = MethodAttributes.Public | MethodAttributes.SpecialName | MethodAttributes.HideBySig;

            MethodBuilder getPropertyBuilder = myTypeBuilder.DefineMethod("get" + PropertyName, getSetAttr, PropertyType, Type.EmptyTypes);

            // Constructing IL Code for get and set Methods.
            ILGenerator GetPropGenerator = getPropertyBuilder.GetILGenerator();

            GetPropGenerator.Emit(OpCodes.Ldarg_0);
            GetPropGenerator.Emit(OpCodes.Ldfld, PropertyFieldBuilder);
            GetPropGenerator.Emit(OpCodes.Ret);

            MethodBuilder setPropertyBuulder = myTypeBuilder.DefineMethod("set_" + PropertyName, getSetAttr, null, new Type[] { PropertyType });

            ILGenerator SetPropGenerator = setPropertyBuulder.GetILGenerator();

            SetPropGenerator.Emit(OpCodes.Ldarg_0);
            SetPropGenerator.Emit(OpCodes.Ldarg_1);
            SetPropGenerator.Emit(OpCodes.Stfld, PropertyFieldBuilder);
            SetPropGenerator.Emit(OpCodes.Ret);

            PBuilder.SetGetMethod(getPropertyBuilder);

            PBuilder.SetSetMethod(setPropertyBuulder);
        }
        //}
        ConstructorInfo objCtor = typeof(object).GetConstructor(new Type[-1 + 1]);
        ConstructorBuilder pointCtor = myTypeBuilder.DefineConstructor(MethodAttributes.Public, CallingConventions.Standard, Type.EmptyTypes);

        ILGenerator ctorIL = pointCtor.GetILGenerator();

        // Constructing IL Code for the Type Constructor.
        ctorIL.Emit(OpCodes.Ldarg_0);
        ctorIL.Emit(OpCodes.Call, objCtor);
        ctorIL.Emit(OpCodes.Ret);

        return myTypeBuilder.CreateType();
    }
  

}
